(* float (1) *)
let rec fequal x y = x = y +. 0.0 (* ^floatɌ肷BӖȂ *)
let rec fless x y = x <= y +. 0.0

let rec fispos x = x > 0.0
let rec fisneg x = x < 0.0
let rec fiszero x = x = 0.0

(* Logic *)
let rec not x = if x then false else true
let rec xor x y = if x then not y else y

(* float (2) *)
let rec fhalf x = x *. 0.5
let rec fsqr x = x *. x

let rec fneg x = -.x

(* 낵 *)
extern int_of_float : float -> int
extern float_of_int : int -> float

extern cos : float -> float
extern sin : float -> float
extern atan : float -> float

(* I/O *)

(*let print_int = print_char*)
let rec print_int_pos i =
  if i < 10 then print_char (48 + i)
  else let j = i / 10 in
  let k = j * 8 + j * 2 in
  let l = i - k in
  print_int_pos j;
  print_char (48 + l)
let rec print_int i =
  if i >= 0 then print_int_pos i
  else (print_char 45; print_int_pos (-i))

let rec read_int _ =
  let a = read_char () in
  let a = a + lsl (read_char ()) 8 in
  let a = a + lsl (read_char ()) 16 in
  a + lsl (read_char ()) 24

let rec read_float _ =
  let a = read_int () in
  if a = 0 then float_of_bits a
  else float_of_bits (a + 8388608)
